
//////////////////////////////

// "The scale distortion in a north-south direction parallel to the central
// meridian (CM) is constant However, the scale distortion increases either
// direction away from the CM. To equalise the distortion of the map
// across the UTM zone, a scale factor of 0.9996 is applied to all
// distance measurements within the zone."
#define UTM_SCALE .9996

//
// Spheroids
//
//	 0: Clarke 1866 (default)	 1: Clarke 1880
//	 2: Bessel					 3: International 1967
//	 4: International 1909		 5: WGS 72
//	 6: Everest					 7: WGS 66
//	 8: GRS 1980				 9: Airy
//	10: Modified Everest		11: Modified Airy
//	12: WGS 84					13: Southeast Asia
//	14: Australian National		15: Krassovsky
//	16: Hough					17: Mercury 1960
//	18: Modified Mercury 1968	19: Sphere of Radius 6370997 meters

extern double g_major[20];
extern double g_minor[20];

//////////////////////////////

utminvint(double r_maj, double r_min, double scale_fact, long zone);
utminv(double x, double y, double *lon, double *lat);
utminv_degrees(double x, double y, double *lon_degrees, double *lat_degrees);
utmforint(double r_maj, double r_min, double scale_fact, long zone);
utmfor(double lon, double lat, double *x, double *y);
utmfor_degrees(double lon_degrees, double lat_degrees, double *x, double *y);
