/*
    Copyright (C) 1997, 1998, 1999, 2000 by Alex Pfaffe
	(Digital Dawn Graphics Inc)
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef _ddgBox_Class_
#define _ddgBox_Class_

#include "math/ddgvec.h"
#include "struct/ddgnode.h"
#include "struct/ddgcolor.h"
/**
 * A box object for rendering.
 */
class WEXP ddgBox : public ddgNode
{
    typedef ddgNode super;
    /// Box color.
    ddgColor3  _color;
public:
	/// Constructor.
	ddgBox( ddgColor3 *c = NULL ) { if (c) _color.set(c); }
    /// Render the cube.
    bool draw(ddgContext *c);
    /// Create a box.
    bool init(ddgContext *c);
	/// Set color of the box.
	void color( ddgColor3 *c ) { _color.set(c); }
};

#endif
