/*
    Copyright (C) 1997, 1998, 1999, 2000 by Alex Pfaffe
	(Digital Dawn Graphics Inc)
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef _ddgCylinder_Class_
#define _ddgCylinder_Class_
// THIS CLASS IS NOT UPTODATE

#include "struct/ddgnode.h"
#include "render/ddgcamera.h"

/**
 * An cylinder object which will adjust its level of
 * detail based on estimated screen space error.
 */
class WEXP ddgCylinder : public ddgNode
{
    typedef ddgNode super;
    /// 100 points: top, bottom and normal.
    static ddgVector3 buf[300];
    static unsigned short  bufsize;
public:
    /// A RGB colour tuple.
    ddgColor3 color;
	/// Position of cylinder in space.
    ddgVector3 pos;
	/// Position of end of cylinder.
	float   len;
	/// Length of cylinder
	float   radiusx;
	/// Radius of x axis.
	float   radiusy;
	/// Radius of y axis.
	float   ts;	
	/// Starting point (0.0 - 1.0).
	float   te;	
	/// Ending point   (ts - 1.0).
	short	inside:1;
	/// 1 if we want the inside of the cylinder.
	short   topcap:1;
	/// 1 if top cap is present.
	short   botcap:1;
    /// 1 if bottom cap is present.
	short   topin:1;
    /// 1 if top cap is inside, outside otherwise.
	short   botin:1;
    /// 1 if bottom cap is inside, outside otherwise.
	void init(float x = 0, float y = 0, float z = 0, float rx = 2.5, float ry = 2.5,
              float l = 10, float r = 1, float g = 0, float b = 0, float s = 0, float e = 1);
	/// Render the cylinder.
	bool draw(ddgContext *ctx);
	/// Calculate one quadrant of the cylinder.
	void calcq( ddgContext *ctx, float ts, float te, ddgVector3 *ps, ddgVector3 *pe);
	/// Render one quadrant of the cylinder.
	void drawq( ddgVector3 *cap );
};
#endif
