/*
    Copyright (C) 1997, 1998, 1999, 2000 by Alex Pfaffe
	(Digital Dawn Graphics Inc)
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef _ddgGeodesic_Class_
#define _ddgGeodesic_Class_

#include "struct/ddgcolor.h"
#include "render/ddgfacet.h"
/**
 * Class to represent a facet on an icosahedron or
 * a regular subtriangulation thereof.
 */
class WEXP ddgGeodesic : public ddgFacetSet {
    typedef ddgFacetSet super;
	/// Color of the object.
	ddgColor4			_color;
public:
	/// Class constructor.
	ddgGeodesic(unsigned int l = 1) : ddgFacetSet(l) {}
	/// Class destructor.
	~ddgGeodesic();
	/// Draw the object.
	bool draw(ddgContext *ctx);
	/// Set the color.
	void color( ddgColor4 *c) { _color.set(c); }
};
#endif
