/*
    Copyright (C) 1997, 1998, 1999, 2000 by Alex Pfaffe
	(Digital Dawn Graphics Inc)
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef _ddgGrass_Class_
#define _ddgGrass_Class_
#include "struct/ddgnode.h"
#include "math/ddgvec.h"

/**
 * A Tree object.
 */
class WEXP ddgGrass : public ddgNode {
	typedef ddgNode super;
public:
	/// Enumeration of grass types.
	enum ddgGrassType{ grass };
private:
	/// Global class initialization flag.
	static bool ddgGrassInit;
	/// Type of tree.
	ddgGrassType _type;
	/// Number of layers used to simulate the grass.
	unsigned int _depth;
	/// Space between the layers.
	float		_space;
	/// Density as a percentage of surface area.
	unsigned int	_density;
public:
	/// Set bounding box using Min and Max vectors.
	ddgGrass(ddgGrassType t, unsigned int depth = 10, unsigned int density = 30, float space = 0.1 );
	/// Render the tree.
	bool init( ddgContext *ctx );
	/// Render the tree.
	bool draw( ddgContext *ctx);
};

#endif
