/*
    Copyright (C) 1997, 1998, 1999, 2000 by Alex Pfaffe
	(Digital Dawn Graphics Inc)
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef _ddgGround_Class_
#define _ddgGround_Class_

#include "util/ddgclock.h"
#include "struct/ddgcolor.h"
#include "struct/ddgdome.h"
#include "render/ddgvbuf.h"
#include "render/ddgtexture.h"

/**
 * A flat ground texture object which cuts through the world.
 */
class WEXP ddgGround : public ddgVBuffer {
    typedef ddgVBuffer super;
	/// Dome object.
	ddgDome			_dome;
	/// Image used for displayed texture.
	ddgImage	*_image;
	/// The texture object which will hold the image.
	ddgTexture *_texture;

public:
	/// Create a flat Ground object of a given size with a given color.
	ddgGround( ddgImage *image = NULL, ddgColor4 *color = NULL, float size = 4950 );
	/// Destructor.
	~ddgGround( void );
	/// Initialize the object.
	bool init(ddgContext *ctx );
	/// Render the ground object.
	bool draw(ddgContext *ctx );
	/// Return a pointer to the ground image.
	ddgImage *image(void) { return _image;}
};
#endif

