/*
    Copyright (C) 1997, 1998, 1999, 2000 by Alex Pfaffe
	(Digital Dawn Graphics Inc)
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef _ddgLNode_Class_
#define _ddgLNode_Class_

#include "struct/ddgcntxt.h"
#include "struct/ddgnode.h"


/**
 * A node which supports display lists.
 */
class WEXP ddgDLNode : public ddgNode
{
	typedef ddgNode super;
	/// Inidicate if display list is valid.
	bool	_listValid:1;
	/// Display List identifier.
	unsigned int	_listId;
public:
	/// Default constructor.
	ddgDLNode(void) { _listId = 0; _listValid = false; }
	/// Initialize the object with a display list.
	bool init( ddgContext *ctx );
	/// Start Display List
	void listStart(void);
	/// End Display List
	void listEnd(void);
	/// Render Display List
	void listRender(void);
	/// Check state
	bool listValid(void) { return _listValid; }
	/// Set state to invalid
	void listInvalid(void) { _listValid = false; }

};

#endif

