/*
    Copyright (C) 1997, 1998, 1999, 2000 by Alex Pfaffe
	(Digital Dawn Graphics Inc)
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef _ddgScene_Class_
#define _ddgScene_Class_

#include "struct/ddgcolor.h"
#include "struct/ddggroup.h"

/**
 * Root to all objects in the scene.
 * Any number of cameras can be connected to a scene.
 */
class WEXP ddgScene : public ddgGroup
{
    typedef ddgGroup super;
	/// Background color.
	ddgColor3		_color;
	/// If false don't bother clearing the background.
	bool		_clear:1;
public:
	/** Methods
	 * Default to a scene with a black background.
	 */
	ddgScene( ddgColor3 *c = NULL) 
		: _clear(true), _color(0,0,0) { if (c) _color.set(c); }
	/// Default constructor.

	/// Render all the members of the group.
	bool draw( ddgContext *ctx );
    /// Initialize the graphics.
	bool init( ddgContext *ctx );
	/// Set clearing background.
	void clear(bool c) { _clear = c; }
};

#endif
