/*
    Copyright (C) 1997, 1998, 1999, 2000 by Alex Pfaffe
	(Digital Dawn Graphics Inc)
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef _ddgSky_Class_
#define _ddgSky_Class_

#include "util/ddgclock.h"
#include "struct/ddgdome.h"
#include "render/ddgvbuf.h"

/**
 * A semi transparent sky dome that changes color throughout the day.
 */
class WEXP ddgSky : public ddgVBuffer {
    typedef ddgVBuffer super;
	/// Dome object.
	ddgDome			_dome;
	/// Cloud day color.
	ddgColor4	_cday;
	/// Cloud day color.
	ddgColor4	_ctwilight;
	/// Cloud day color.
	ddgColor4	_cnight;
	/// Cloud Brightness.
	float	_bright;
public:
	/// Default constructor.
	ddgSky(float size = 4950);
	/// Initialize the sky object.
	bool init(ddgContext *ctx );
	/// Render the sky object.
	bool draw(ddgContext *ctx );
	/// Set the cloud color.
	void color( ddgColor4 *d, ddgColor4 *t, ddgColor4 *n)
	{ _cday.set(d); _ctwilight.set(t); _cnight.set(n); }
};
#endif

