/*
    Copyright (C) 1997, 1998, 1999, 2000 by Alex Pfaffe
	(Digital Dawn Graphics Inc)
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef _ddgText_Class_
#define _ddgText_Class_

#include "struct/ddgcolor.h"
#include "render/ddguiobj.h"


/**
 * Text Overlay rendering object which can be
 * used to render 2D lines of text onto the canvas.
 */
class WEXP ddgText : public ddgUIObj
{
    typedef ddgUIObj super;
	/// Text to render.
	ddgStr			_data;
	/// Screen width and height.
	ddgVector2		_screen;
public:
	/// Blend texture with background.
	bool		blend;
	/// Background color default black.
	ddgColor4		background;
	/// Create a text object at a given canvas location.
	ddgText(unsigned int x = 0, unsigned int y = 0, unsigned int w = 640, unsigned int h = 480)
		: ddgUIObj(x,y), blend(true), background(0,0,0,255), _screen(w,h) {}
	/// Initialize the font data.
	bool init(ddgContext *ctx);
	/// Store a string in the Text object.
    void printf(char *str, ...);
	/// Render the string.
    bool draw(  ddgContext *ctx );
};

#endif
