/*
    Copyright (C) 1997, 1998, 1999 by Alex Pfaffe
	(Digital Dawn Graphics Inc)
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef _ddgTorus_Class_
#define _ddgTorus_Class_

#include "math/ddgvec.h"
#include "struct/ddgcolor.h"
#include "struct/ddgnode.h"
/**
 * A torus object for rendering.
 */
class WEXP ddgTorus : public ddgNode
{
    typedef ddgNode super;
    /// Torus color.
    ddgColor3 _color;
	float _r; ///inside radius
	float _R; ///outside radius
	float _nsides; ///number of sides
	float _rings; ///number of rings

public:
	/// Constructor.
	ddgTorus(float r, float R, float rings, float nsides, ddgColor3 * c) 
	{ 
		if (c) _color.set(c); 
		_rings = rings;
		_nsides = nsides;
		_r = r;
		_R = R;
	}
    /// Render the torus.
    bool draw(ddgContext *c);
    /// Create a torus.
    bool init(ddgContext *c);
	/// Set color of the torus.
	void color( ddgColor3 *c ) { _color.set(c); }
	//Set the number of rings
	void rings( float r);
	//Set the number of sides
	void nsides(float n);
	//Set the outer Radius
	void outer(float R);
	//set the inner Radius
	void inner(float r);
};

#endif
