/*
    Copyright (C) 1997, 1998, 1999, 2000 by Alex Pfaffe
	(Digital Dawn Graphics Inc)
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef _ddgUIObj_Class_
#define _ddgUIObj_Class_

#include "struct/ddggroup.h"

/**
 * UI object, rendered by a given camera.
 */
class WEXP ddgUIObj : public ddgNode
{
    typedef ddgNode super;
	/// X position on canvas as a percentage of total width.
	unsigned short	_x;
	/// Y position on canvas as a percentage of total height.
	unsigned short	_y;
public:
	ddgUIObj( unsigned short x, unsigned short y);
	/// Set the string location.
	void pos(unsigned int x, unsigned int y)
	{
		_x = x;
		_y = y;
	}
	/// Return x pos.
	unsigned short posx(void) { return _x; }
	/// Return y pos.
	unsigned short posy(void) { return _y; }
};


/**
 * This object manages a list of ui objects.
 * this object is typically associated with a camera.
 */
class WEXP ddgUIGroup : public ddgGroup
{
    typedef ddgGroup super;
    /// Window width.
    static unsigned int _width;
	/// Window height.
    static unsigned int _height;
public:
	/// Set the width and height of the window.
    static void area( unsigned int w, unsigned int h);
	/// Draw the objects managed by this group.
	bool draw( ddgContext *ctx );
};
#endif
