/*
    Copyright (C) 1997, 1998, 1999, 2000 by Alex Pfaffe
	(Digital Dawn Graphics Inc)
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef _ddgDome_Class_
#define _ddgDome_Class_

#include "struct/ddgvarr.h"

/**
 * A dome shape.
 */
class WEXP ddgDome {
	/// Radius of sphere.
	float	_radius;
	/// Size of arc of sphere.
	float	_arc;
	/// Step size.
	unsigned int _step;
	/// Is the dome flat.
	bool	_flat:1;
public:
	/// Create a Dome object.
	ddgDome( bool f = false);

	/// Initialize the dome object.
	bool init(ddgVArray *varray, bool texture, bool color);
	/// Sphere radius and arc width.
	void sphere( float r, float a ) { _radius = r; _arc = a; }
};
#endif

