/*
    Copyright (C) 1997, 1998, 1999, 2000 by Alex Pfaffe
	(Digital Dawn Graphics Inc)
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "struct/ddgevent.h"
// ----------------------------------------------------------------------
ddgEventHandler::ddgEventHandler(void)
{
	_defaultHandler = NULL;
	handlerObject(NULL);
	keyHandler(skey);
	specialKeyHandler(sspecialKey);
	mouseMotionHandler(smouseMotion);
	mouseHandler(smouse);
}
void ddgEventHandler::set( 
										   void *obj,
										   KeyHandlerFn skey,
										   SpecialKeyHandlerFn sspecialKey,
										   MouseHandlerFn smouse,
										   MouseMotionHandlerFn smouseMotion
										   )
{
	handlerObject(obj);
	keyHandler(skey);
	specialKeyHandler(sspecialKey);
	mouseMotionHandler(smouseMotion);
	mouseHandler(smouse);
}

/// Event handler, returns true if event was handled.
bool ddgEventHandler::smouse(void *obj, int button, int state, int x, int y)
{
	return false;
}
/// Event handler, returns true if event was handled.
bool ddgEventHandler::smouseMotion(void *obj, int x, int y)
{
	return false;
}
/// Event handler, returns true if event was handled.
bool ddgEventHandler::sspecialKey(void *obj, int k, int x, int y)
{
	return false;
}
/// Event handler, returns true if event was handled.
bool ddgEventHandler::skey(void *obj, unsigned char k, int x, int y)
{
	return false;
}