/*
    Copyright (C) 1997, 1998, 1999, 2000 by Alex Pfaffe
	(Digital Dawn Graphics Inc)
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef _ddgOctTree_Class_
#define _ddgOctTree_Class_

#include "math/ddgbbox.h"
/**
 * The OctTree organizes objects spatially.
 * It consists of a hierarchy of nodes.
 *
 * Assumptions:
 * Objects are inserted into the minimum sized node that can fit them.
 * if there are more than N objects in a node, the node is split.
 */
class ddgOctTree : public ddgBBox3 {
    typedef ddgBBox3 super;
    /// This array stores the order of the octree corners.
	ddgBBox3	_bbox;
    /// If true this node and its children are visible.
    bool  _visible:1;
    /**
    * The children in the subtree if any.
    */
    ddgOctTree *_sublevels[8];
public:
	/// Insert an object into the octtree.
	bool insert(void *pn, ddgBBox3 *pbb);
	/// Remove an object from the octtree.
	bool remove(void *pn, ddgBBox3 *pbb);
};

#endif
