/*
    Copyright (C) 1997, 1998, 1999, 2000 by Alex Pfaffe
	(Digital Dawn Graphics Inc)
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "util/ddgerror.h"
#include "render/ddgbox.h"
// ----------------------------------------------------------------------

float verticesf[8][3] = {{1,1,1},{ 1,1,-1},{ 1,-1,1},{ 1,-1,-1},
                       {-1,1,1},{-1,1,-1},{-1,-1,1},{-1,-1,-1}};
ddgVector3 *vertices = (ddgVector3*)verticesf;
GLint    tris[12][3] = {{0,1,4},{1,5,4},{1,0,2},{1,2,3},{5,1,3},{5,3,7},
                        {4,5,7},{4,7,6},{0,4,6},{0,6,2},{3,2,6},{3,6,7}};
float normsf[12][3];
ddgVector3 *norms = (ddgVector3*)normsf;
int trinum = 12;
  
bool ddgBox::init(ddgContext *c )
{
    if (super::init(c)) return ddgFailure;
    ddgVector3 n;
	int i;
    for ( i=0; i < trinum; i++)
        {
        n.normal(&(vertices[tris[i][0]]),
                 &(vertices[tris[i][1]]),
                 &(vertices[tris[i][2]]));
        n.normalize();
        n.assign(norms[i]);
        }

    return ddgSuccess;
}

bool ddgBox::draw(ddgContext*)
{
    int i;
	glColor3ubv(_color.v);
    // Draw the object.
    glBegin(GL_TRIANGLES);
    for ( i = 0; i < trinum; i++)
		{
		glNormal3fv(norms[i]); 
		glVertex3fv(vertices[tris[i][0]]); 
		glVertex3fv(vertices[tris[i][1]]); 
		glVertex3fv(vertices[tris[i][2]]); 
		}
    glEnd();
	/*
    glColor3ub(0,255,255);
    glBegin(GL_LINES);
    for ( i = 0; i < trinum; i++)
		{
		ddgVector3 tmp;
		tmp.set(&(vertices[tris[i][0]])); glVertex3fv(tmp);
		tmp.add(&(norms[i]));             glVertex3fv(tmp);
		tmp.set(&(vertices[tris[i][1]])); glVertex3fv(tmp);
		tmp.add(&(norms[i]));             glVertex3fv(tmp);
		tmp.set(&(vertices[tris[i][2]])); glVertex3fv(tmp);
		tmp.add(&(norms[i]));             glVertex3fv(tmp);
		}
    glEnd();
	*/
	return false;
}


