/*
    Copyright (C) 1997, 1998, 1999, 2000 by Alex Pfaffe
    (Digital Dawn Graphics Inc)
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
// ----------------------------------------------------------------------
// General includes
#include <string.h>

#include "render/ddgfbuf.h"

// ----------------------------------------------------------------------

bool ddgFrameBuffer::readZBuffer( ddgCamera *c )
{
    int vp[4] = {0,0,-1,-1};
    c->viewport(vp);

    // - Retrieve Depth value at that location.
    glReadBuffer(GL_BACK);
    if (allocate(vp[3],vp[2],1))
        return true;
    glReadPixels(0,0,vp[2],vp[3],GL_DEPTH_COMPONENT,GL_UNSIGNED_BYTE,buffer());
    return false;
}

bool ddgFrameBuffer::readFrameBuffer( ddgCamera *c )
{
    int vp[4] = {0,0,-1,-1};
    c->viewport(vp);

    // - Retrieve Depth value at that location.
    glReadBuffer(GL_BACK);
    if (allocate(vp[3],vp[2],3))
        return true;
    glReadPixels(0,0,vp[2],vp[3],GL_RGB,GL_UNSIGNED_BYTE,buffer());
    return false;
}

bool ddgFrameBuffer::readAlphaBuffer( ddgCamera *c )
{
    int vp[4] = {0,0,-1,-1};
    c->viewport(vp);

    // - Retrieve Depth value at that location.
    glReadBuffer(GL_BACK);
    if (allocate(vp[3],vp[2],1))
        return true;
    glReadPixels(0,0,vp[2],vp[3],GL_ALPHA,GL_UNSIGNED_BYTE,buffer());
    return false;
}






