/*
    Copyright (C) 1997, 1998, 1999, 2000 by Alex Pfaffe
	(Digital Dawn Graphics Inc)
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "render/ddghistg.h"

// ----------------------------------------------------------------------
bool ddgHistograph::init(ddgContext *ctx)
{
	if ( super::init(ctx))
        return ddgFailure;

	return _histogram.init();
}


bool ddgHistograph::draw( ddgContext *ctx )
{
	float x = posx(), y = posy()+_height;
	unsigned int i = 0;
	// Begin the rendering.
	// Texture mode is MODULATE.
	// Always render regardless of Zbuffer.
	// Blend with existing image.
	glShadeModel(GL_FLAT);
	glDepthFunc(GL_ALWAYS);
	if (!blend)
	{
		glBegin(GL_QUADS);
		glColor4ubv(background);
		glVertex3f(x,y-_height,0);
		glVertex3f(x+_width,y-_height,0);
		glVertex3f(x+_width,y,0);
		glVertex3f(x,y,0);
		glEnd();
	}
	float dx = (float)_width/(float)_histogram.size();
	float dy = (float)_height/(float)(_histogram.maxVal()?_histogram.maxVal():1);

	glColor4ubv(foreground);
	glBegin(GL_LINES);
	for (i = 0; i < _histogram.size(); i++)
	{
		glVertex3f( x,y,0);
		glVertex3f( x,y-dy*_histogram.data(i),0);
		//
		x +=dx;
	}
	glEnd();
	glDepthFunc(GL_LESS);
	return ddgSuccess;
}
