/*
    Copyright (C) 1997, 1998, 1999, 2000 by Alex Pfaffe
	(Digital Dawn Graphics Inc)
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "util/ddgerror.h"
#include "render/ddglnode.h"

bool ddgDLNode::init(ddgContext *ctx)
{
	if (super::init(ctx))
        return true;

	_listId=glGenLists(1);
	return false;
}

void ddgDLNode::listStart(void)
{
	_listValid = false;
	glNewList(_listId, GL_COMPILE);
}

void ddgDLNode::listEnd(void)
{
	glEndList();
	_listValid = true;
}

void ddgDLNode::listRender(void)
{
	ddgAsserts(_listValid,"The display list is not valid at this time.");
	if (_listValid)
		glCallList(_listId);
}