/*
    Copyright (C) 1997, 1998, 1999, 2000 by Alex Pfaffe
	(Digital Dawn Graphics Inc)
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
//
#include "render/ddgsquare.h"
// ----------------------------------------------------------------------

static float verticesf[4][3] = {{1,0,1},{1,0,-1},{-1,0,1},{-1,0,-1}};
ddgVector3 *sqvertices = (ddgVector3*)verticesf;
static GLint    tris[2][3] = {{0,2,1},{1,2,3}};
static float normsf[2][3];
ddgVector3 *sqnorms = (ddgVector3*)normsf;
static int trinum = 2;
  
bool ddgSquare::init(ddgContext *c )
{
    if (ddgNode::init(c)) return true;
    ddgVector3 n;
	int i;
    for ( i=0; i < trinum; i++)
        {
        n.normal(&(sqvertices[tris[i][1]]),
                 &(sqvertices[tris[i][0]]),
                 &(sqvertices[tris[i][2]]));
        n.normalize();
        n.assign(sqnorms[i]);
        }

    return false;
}

bool ddgSquare::draw(ddgContext*)
{
    int i;
	glColor3ubv(_color.v);
    // Draw the object.

    glBegin(GL_TRIANGLES);
    for ( i = 0; i < trinum; i++)
		{
		glNormal3fv(sqnorms[i]); 
		glVertex3fv(sqvertices[tris[i][0]]); 
		glVertex3fv(sqvertices[tris[i][1]]); 
		glVertex3fv(sqvertices[tris[i][2]]); 
		}
    glEnd();

    glColor3ub(0,255,255);
    glBegin(GL_LINES);
    for ( i = 0; i < trinum; i++)
		{
		ddgVector3 tmp;
		tmp.set(&(sqvertices[tris[i][0]])); glVertex3fv(tmp);
		tmp.add(&(sqnorms[i]));             glVertex3fv(tmp);
		tmp.set(&(sqvertices[tris[i][1]])); glVertex3fv(tmp);
		tmp.add(&(sqnorms[i]));             glVertex3fv(tmp);
		tmp.set(&(sqvertices[tris[i][2]])); glVertex3fv(tmp);
		tmp.add(&(sqnorms[i]));             glVertex3fv(tmp);
		}
    glEnd();

	return false;
}


