/*
    Copyright (C) 1997, 1998, 1999, 2000 by Alex Pfaffe
	(Digital Dawn Graphics Inc)
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>

#include "render/ddguicolor.h"
// ----------------------------------------------------------------------
unsigned int ddgUIControl::_gid = 0;
ddgList	*ddgUIControl::_guicontrollist = 0;


ddgUIControl::ddgUIControl(unsigned short x, unsigned short y)
	: super(x,y)
{
}

bool ddgUIControl::init( void )
{
	// Initialize the MUI system if needed.
	static bool _muiInit = false;
	if (!_muiInit)
	{
//		muiInit();
//		muiNewUIList(1);
		_muiInit = true;
	}
	_id = genId();
	// Create the global ui control list if needed.
	if (!_guicontrollist)
		_guicontrollist = new ddgList();
	// Add ourselves to this list.
	_guicontrollist->add(new ddgUINode(this));
	return false;
}

/// Get new id.
unsigned int ddgUIControl::genId(void)
{
	return _gid++;
}

ddgUIControl* ddgUIControl::find(unsigned int id)
{
    ddgUINode *c = (ddgUINode*) _guicontrollist->head(), *p = NULL;
    while (c && c->uicontrol->id() < id)
	{
		p = c;
    	c = (ddgUINode *) c->next();
	}
	return p ? p->uicontrol : NULL;
}

// ----------------------------------------------------------------------

#define UIslw	150
#define UIslh	25
#define UIsls	25
/*
void	slcallback(muiObject *obj, enum muiReturnValue value)
{
    if ((value != MUI_SLIDER_RETURN) && (value != MUI_SLIDER_THUMB)) return;
	UIControl *uic = UIControl::find(muiGetID(obj));
	if (uic)
		uic->update(muiGetID(obj));
}
*/

ddgUIColor::ddgUIColor( unsigned short x, unsigned short y, ddgColor3 *c )
: super(x,y)
{
	_color3 = c;
	_is4 = false;
}

ddgUIColor::ddgUIColor( unsigned short x, unsigned short y, ddgColor4 *c )
: ddgUIControl(x,y)
{
	_color4 = c;
	_is4 = true;
}

bool ddgUIColor::init( void )
{
	if (ddgUIControl::init())
		return true;
/*
	muiObject *mo;
	if (mo = muiNewHSlider(2 + UIsls, 2 + 3*UIslh, UIslw + UIsls, 0, 5))
	{
		muiSetHSArrowDelta(mo, 0.1);
		muiSetCallback(mo, slcallback);
		muiSetID(mo, _idalpha = genId());
		_slalpha = mo;
	}
    if (mo = muiNewHSlider(2 + UIsls, 2+2*UIslh, UIslw + UIsls, 0, 5))
	{
		muiSetHSArrowDelta(mo, 0.1);
		muiSetCallback(mo, slcallback);
		muiSetID(mo, _idred = genId());
		_slred = mo;
	}
    if (mo = muiNewHSlider(2 + UIsls, 2+UIslh, UIslw + UIsls, 0, 5))
	{
		muiSetHSArrowDelta(mo, 0.1);
		muiSetCallback(mo, slcallback);
		muiSetID(mo, _idgreen = genId());
		_slgreen = mo;
	}
    if (mo = muiNewHSlider(2 + UIsls, 2, UIslw + UIsls, 0, 5))
	{
		muiSetHSArrowDelta(mo, 0.1);
		muiSetCallback(mo, slcallback);
		muiSetID(mo, _idblue = genId());
		_slblue = mo;
	}

    _labalpha = muiNewLabel(2, 6+3*UIslh, "-");
    _labred = muiNewLabel(2, 6+2*UIslh, "-");
    _labgreen = muiNewLabel(2, 6+UIslh, "-");
    _labblue = muiNewLabel(2, 6, "-");
*/
	update(0);
	return true;
}

bool ddgUIColor::update( unsigned int id )
{
/*
	muiSetActive((muiObject*)_slalpha, _is4 ? 1 : 0);
	muiSetActive((muiObject*)_labalpha, _is4 ? 1 : 0);
	if (id == 0)
	{
		muiSetHSValue((muiObject*)_slred,   _color3->v[0]);
	    muiSetHSValue((muiObject*)_slgreen, _color3->v[1]);
	    muiSetHSValue((muiObject*)_slblue,  _color3->v[2]);
		muiSetHSValue((muiObject*)_slalpha, _is4 ? _color4->v[3] : 0);
	}
	else if (id == _idred)
		_color3->v[0] = muiGetHSVal((muiObject*)_slred);
	else if (id == _idgreen)
		_color3->v[1] = muiGetHSVal((muiObject*)_slgreen);
	else if (id == _idblue)
		_color3->v[2] = muiGetHSVal((muiObject*)_slblue);
	else if (id == _idalpha)
		_color4->v[3] = muiGetHSVal((muiObject*)_slalpha);

	char s[10];
	sprintf(s,"%3.2f",_color3->v[0]);
    muiChangeLabel((muiObject*)_labred, s);
	sprintf(s,"%3.2f",_color3->v[1]);
    muiChangeLabel((muiObject*)_labgreen, s);
	sprintf(s,"%3.2f",_color3->v[2]);
    muiChangeLabel((muiObject*)_labblue, s);
	sprintf(s,"%3.2f",_is4 ? _color4->v[3] : 0);
	muiChangeLabel((muiObject*)_labalpha, s);
*/
	return false;
}

bool ddgUIColorView::draw( ddgContext *ctx )
{
	glBegin(GL_QUADS);
	glColor3ub(_color3->v[0],0,0);
	glVertex2f(0,0); glVertex2f(50,0);
	glVertex2f(50,33); glVertex2f(0,33);
	glColor3ub(0,_color3->v[1],0);
	glVertex2f(0,33); glVertex2f(50,33);
	glVertex2f(50,66); glVertex2f(0,66);
	glColor3ub(0,0,_color3->v[2]);
	glVertex2f(0,66); glVertex2f(50,66);
	glVertex2f(50,100); glVertex2f(0,100);
	glEnd();
	if (_is4)
	{
		glEnable(GL_BLEND);
		glBlendFunc(GL_ONE,GL_ZERO);
		glBegin(GL_QUADS);
		// Make a black background.
		glColor3ub(0,0,0);
		glVertex2f(50,0); glVertex2f(100,0);
		glVertex2f(100,100); glVertex2f(50,100);
		// Draw some white squares.
		glColor3ub(255,255,255);
		int i,j;
		for (i = 0; i < 5; i++)
			for (j = 0; j < 10; j++)
			{
				glVertex2f(50+i*10,0+j*10);
				glVertex2f(55+i*10,0+j*10);
				glVertex2f(55+i*10,5+j*10);
				glVertex2f(50+i*10,5+j*10);
				glVertex2f(55+i*10,5+j*10);
				glVertex2f(60+i*10,5+j*10);
				glVertex2f(60+i*10,10+j*10);
				glVertex2f(55+i*10,10+j*10);
			}
		glEnd();
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		glBegin(GL_QUADS);
		glColor4ubv(_color4->v);
		glVertex2f(50,0); glVertex2f(100,0);
		glVertex2f(100,100); glVertex2f(50,100);
		glEnd();
		glDisable(GL_BLEND);
	}
	else
	{
		glBegin(GL_QUADS);
		glColor3ubv(_color3->v);
		glVertex2f(50,0); glVertex2f(100,0);
		glVertex2f(100,100); glVertex2f(50,100);
		glEnd();
	}
	return false;
}


bool ddgUIColorList::update( unsigned int id )
{
	return false;
}

bool ddgUIColorList::init( void )
{
	return false;
}