/*
    Copyright (C) 1997, 1998, 1999, 2000 by Alex Pfaffe
	(Digital Dawn Graphics Inc)
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/// THIS FILE and the ddgParam class WILL PROBABLY BE ELIMINATED.
#include "gl/glut.h"
#include "util/ddgerror.h"
#include "ddgparam.h"

// ----------------------------------------------------------------------
void ddgParamSet::help(void)
{
#ifdef DDGSTREAM
	ddgParamSetNode *psn = (ddgParamSetNode *) head();
    cerr << "General controls:\n" 
        "CTRL ............... 5 times a fast.\n"
        "ALT ................ 50 times a fast.\n";
	while(psn)
    {
		ddgParam *p = psn->p();
		if (p->key())
			cerr << p->key() << " .................. ";
        else if (p->controlD() == GLUT_KEY_LEFT)
			cerr << " LEFT/RIGHT ......... ";
        else if (p->controlD() == GLUT_KEY_DOWN)
			cerr << " DOWN/UP ............ ";

		cerr << p->desc() << endl;
		psn = (ddgParamSetNode *) psn->next();
    }
#endif
}

void ddgParamSet::add( ddgParam *p )
{
#ifdef _DEBUG
	ddgParamSetNode *psn = (ddgParamSetNode *) head();
	while(psn)
    {
		ddgParam *p = psn->p();
		ddgAssert(p);
		psn = (ddgParamSetNode *) psn->next();
    }
#endif
	super::add( new ddgParamSetNode(p));
}

bool ddgParamSet::key(unsigned char k, int x, int y, int sk)
{
    unsigned char key = k ? tolower(k) : 0;
    ddgParam *p = find(key,sk);
    if (!p) return false;  // The specified key has no parameter associated with it.
    
    bool decr = false;
    
    // If lowercase we are decrementing if uppercase we are incrementing.
    if ((k && k == key) || (!k && sk == p->controlD()))
        decr = true;

    if (glutGetModifiers() == GLUT_ACTIVE_CTRL) 
    {
        if (decr) p->fdecr();
        else p->fincr();
    }
    else if (glutGetModifiers() == GLUT_ACTIVE_ALT)
    {
        if (decr) p->sdecr();
        else p->sincr();
    }
    else
    {
        if (decr) p->decr();
        else p->incr();
    }
    return true;   // key was processed here.
}
